.386 
.model flat,stdcall 
option casemap:none 

include windows.inc
include kernel32.inc
include user32.inc
include gdi32.inc
include Comctl32.inc
include comdlg32.inc
include shell32.inc
include masm32.inc
include advapi32.inc
include dbghelp.inc

includelib kernel32.lib
includelib user32.lib
includelib gdi32.lib
includelib Comctl32.lib
includelib comdlg32.lib
includelib shell32.lib
includelib masm32.lib
includelib advapi32.lib
includelib dbghelp.lib


DlgProc		proto		:DWORD,:DWORD,:DWORD,:DWORD 
OpenFileProc    proto           :DWORD
OutputInfo      proto           :DWORD,:DWORD
PEinfo          proto           :DWORD
EnableDebugPrivilege  proto     :DWORD
SaveDumpFile    proto           :DWORD,:DWORD,:DWORD

.const
IDD_MAIN        equ 1000
IDC_FileName    equ 1002
IDC_OPEN        equ 1003
IDC_GET         equ 1007
IDC_ABOUT       equ 1011
IDC_Exit        equ 1010
IDC_OutInf      equ 1012
ico 	        equ 2001


.data
startinfo       STARTUPINFO <> 
ProcessInfo     PROCESS_INFORMATION <> 
Context         CONTEXT <>
DBEvent         DEBUG_EVENT <> 
ldte            LDT_ENTRY <> 
Format          db """%s"" %s",0
bFirstBreakPoint    db 1
firstbp         dd 0
secondbp        dd 0
oldbyte         dd 0
AddrSec         dd 0
NumOfSec        dd 0
ImageBase       dd 0
EntryPiont      dd 0
dumpsize        dd 0
SizeOfIAT       dd 0
ImageSize       dd 0
SizeOfImportDir dd 0
AddrImportDir   dd 0
SecAlign        dd 0
RawLastSec      dd 0
VarLastSec      dd 0

.data? 
hDlg            HINSTANCE       ?
hInstance	HINSTANCE	?  
DllEntryPoint   dd ?
FilePath        db 256 dup(?)
OutBuff         db 256 dup(?)
TempPath        db MAX_PATH dup (?)
hDll            dd ?
myProcess       dd ?
myThread        dd ?
myProcessId     dd ?
myThreadId      dd ?
subThread       dd ?
pOldStartAddressCode db ?
pDllName          db 512 dup(?)
outinf            db 1024 dup(?)
DllBase          dd ?
dwModBase        dd ?
SizeOfImage      dd ?
CTEXT macro Text:VARARG
	local szText
	.data
	 szText byte Text, 0
	.code
	exitm <offset szText>
endm

include DllUnpack.inc

.code 
start: 
        invoke EnableDebugPrivilege,TRUE
        invoke GetModuleHandle, NULL 
        mov    hInstance,eax 
        invoke InitCommonControls
        invoke DialogBoxParam, hInstance, IDD_MAIN, NULL, addr DlgProc, NULL 
        invoke ExitProcess,eax 
    
DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 
        .if uMsg == WM_INITDIALOG
                push    hWnd
                pop     hDlg
	        invoke	LoadIcon,hInstance,ico
	        invoke	SendMessage,hWnd,WM_SETICON,1,eax
	        invoke  SetFocus,eax 
	        call DelLog
        .elseif uMsg == WM_COMMAND
	        mov	eax,wParam
	        .if eax==IDC_OPEN
	                lea eax,FilePath
                        mov dword ptr [eax],0
                        invoke OpenFileProc,eax         
                        .if eax!=0
           	                invoke SetDlgItemText,hWnd,IDC_FileName,addr FilePath
                        .endif
                        invoke SetDlgItemText,hWnd,IDC_OutInf,0 
	        .elseif eax==IDC_GET 
	        	call LoadDll	            
	                invoke GetDlgItemText,hWnd,IDC_FileName,addr FilePath,MAX_PATH
	                invoke PEinfo,addr FilePath
	                call ProcessDll
	                call FreeDll
	        .elseif eax==IDC_ABOUT 
		        invoke MessageBox,NULL,CTEXT(13," Unpacker by laomms ",13,13,"  --===2008.5===-- ",0) ,CTEXT("About"),MB_OK
	        .elseif eax==IDC_Exit 
	        	invoke ExitProcess,0
	        .endif
        .elseif	uMsg == WM_CLOSE
	        invoke	EndDialog,hWnd,0
        .endif        
        xor	eax,eax
        ret 
DlgProc endp 
OpenFileProc proc   OpenFileNameBuffer:DWORD
LOCAL ofn :OPENFILENAME 
        lea esi, ofn
        mov ecx, sizeof OPENFILENAME
@@:
        mov byte ptr [esi+ecx-1],0
        dec ecx
        jnz @b
        mov  ofn.lStructSize,SIZEOF OPENFILENAME
        push    hDlg
        pop  ofn.hWndOwner
        mov ofn.lpstrCustomFilter,0    
        push hInstance
        pop  ofn.hInstance
        mov  ofn.lpstrFilter, CTEXT("PE File(*.dll)", 0, "*.dll", 0,13,10,"All",0,"*.*",0 , 0) 
        mov eax,OpenFileNameBuffer
        mov  ofn.lpstrFile, eax
        mov  ofn.nMaxFile, MAX_PATH
        mov  ofn.Flags, OFN_FILEMUSTEXIST or  OFN_PATHMUSTEXIST or OFN_LONGNAMES or  OFN_EXPLORER
        mov ofn.lpstrTitle,CTEXT("Open a PE File")
        invoke GetOpenFileName, ADDR ofn   
	ret               
OpenFileProc endp
PEinfo proc  szFilePath:DWORD
LOCAL hFile,hMap,pMap:DWORD
LOCAL Buffer[256]:byte
  
	invoke OutputInfo,CTEXT("Open PE file...",13,10,0),0
        invoke CreateFile,szFilePath,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
        .if eax==INVALID_HANDLE_VALUE
        	  invoke MessageBox,hDlg,CTEXT("Open File Error!"),CTEXT("Error"),MB_ICONERROR
                  invoke OutputInfo,CTEXT("Open File Error!",13,10,0),0
  	          ret
        .endif
        mov hFile,eax
        invoke CreateFileMapping,hFile,0,PAGE_READONLY,0,0,0
        .if eax==0
        	 invoke CloseHandle,hFile
  	         invoke MessageBox,hDlg,CTEXT("CreateFileMapping Error!"),CTEXT("Error"),MB_ICONERROR
                 invoke OutputInfo,CTEXT("CreateFileMapping Error!"),0
                 ret
        .endif
        mov hMap,eax
        invoke MapViewOfFile,hMap,FILE_MAP_READ,0,0,0
        .if eax==0
		invoke	MessageBox,hDlg,CTEXT("MapViewOfFile Error...") ,CTEXT("Error") ,MB_OK or MB_ICONEXCLAMATION
		invoke	CloseHandle,hMap
		ret
        .endif  
        mov pMap,eax
        mov edi,eax
        cmp word ptr [edi],"ZM"
        jne notPE
        add edi, [edi+03ch]
        cmp word ptr [edi],"EP"
        jne notPE
        jmp isPE
notPE:
        invoke MessageBox,hDlg,CTEXT("Not a PE file!") ,CTEXT("Error"),MB_ICONERROR    
        invoke OutputInfo,CTEXT("Not a PE file!"),0
        invoke UnmapViewOfFile,pMap
        invoke CloseHandle,hMap
        invoke CloseHandle,hFile
        mov eax,-1
        ret
isPE:
        invoke OutputInfo,CTEXT("valid PE file",13,10,0),0        
        assume edi:ptr IMAGE_NT_HEADERS  
      
        push [edi].OptionalHeader.AddressOfEntryPoint
        pop EntryPiont  
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("entry point"),EntryPiont
        invoke OutputInfo,addr Buffer,0
        push [edi].OptionalHeader.ImageBase
        pop ImageBase
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("reading imagebase"),ImageBase
        invoke OutputInfo,addr Buffer,0
      
        mov eax, [edi].OptionalHeader.SizeOfImage 
        mov ImageSize,eax
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("SizeOfImage"),ImageSize 
        invoke OutputInfo,addr Buffer,0

     
        mov eax,edi
        add eax,80h ;ImportDirectory VA
        sub eax,pMap
        mov SizeOfImportDir,eax
        add eax,4
        mov AddrImportDir,eax ;ImportDirectory Size
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("reading address of Import Directory VA value"),AddrImportDir
        invoke OutputInfo,addr Buffer,0
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("reading address of Import Directory Size value"),SizeOfImportDir
        invoke OutputInfo,addr Buffer,0   
  
        mov eax, [edi].OptionalHeader.SectionAlignment
        mov SecAlign,eax
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("reading section alignment"),SecAlign
        invoke OutputInfo,addr Buffer,0  
  
        movzx ecx,word ptr [edi].FileHeader.NumberOfSections
        mov NumOfSec,ecx
        mov esi,edi
        add esi,sizeof IMAGE_NT_HEADERS
        assume esi:ptr IMAGE_SECTION_HEADER 
        mov eax,esi
        sub eax,pMap
        mov AddrSec,eax
        xor eax,eax
sect_loop:
        add eax,dword ptr[esi].Misc.VirtualSize
        add esi,sizeof IMAGE_SECTION_HEADER
        loop sect_loop
        add eax,1000h ;Headersize
        mov dumpsize,eax
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("calculating dumpsize (virtual size sum of all sections)"),dumpsize
        invoke OutputInfo,addr Buffer,0  

        sub esi,sizeof  IMAGE_SECTION_HEADER
        lea eax, [esi].Misc.VirtualSize
        sub eax,pMap
        mov VarLastSec,eax
        lea eax, [esi].SizeOfRawData
        sub eax,pMap
        mov RawLastSec,eax
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("reading VirtualSize value of last section"),VarLastSec
        invoke OutputInfo,addr Buffer,0  
        invoke wsprintf,addr Buffer,CTEXT("%s: %.08X",13,10,0),CTEXT("reading SizeOfRawData value of last section"),RawLastSec
        invoke OutputInfo,addr Buffer,0 
        invoke OutputInfo,CTEXT("have all needed values, closing file",13,10,13,10,0) ,0      
        invoke UnmapViewOfFile,pMap
        invoke CloseHandle,hMap
        invoke CloseHandle,hFile
  
        assume edi:nothing
        assume esi:nothing 
       
        ret
PEinfo endp
Unicode2Ansi proc iString,ouptbuf
        invoke lstrlen,ouptbuf
        invoke WideCharToMultiByte,CP_ACP,0,iString,-1,ouptbuf,eax,0,0
        invoke WideCharToMultiByte,CP_ACP,0,iString,-1,ouptbuf,eax,0,0
        invoke WideCharToMultiByte,CP_ACP,0,iString,-1,ouptbuf,eax,0,0
        ret
Unicode2Ansi endp
ProcessDll proc
LOCAL Buffer [64]:byte
LOCAL EP,EP_data:dword
LOCAL hProcess:dword
LOCAL tempaddr:dword
LOCAL dlls_imported,PatchAddr:dword
LOCAL szContext[1024]:byte
LOCAL TEB,LDR:dword

        invoke GetTempPath, sizeof TempPath, addr TempPath
        invoke wsprintf,addr OutBuff,addr Format,addr loaddllPath,addr FilePath  
        invoke GetStartupInfo,addr startinfo
        invoke CreateProcess,NULL,addr OutBuff,NULL,NULL,FALSE,DEBUG_PROCESS+DEBUG_ONLY_THIS_PROCESS ,NULL,addr TempPath,addr startinfo,addr ProcessInfo
        .while TRUE       	
       	        invoke WaitForDebugEvent,addr DBEvent,INFINITE	      
       	        .if DBEvent.dwDebugEventCode == EXIT_PROCESS_DEBUG_EVENT            	      	     
       	      	        invoke OutputInfo,CTEXT("Exit Debug"),0       	      	     
       	      	        .break 
       	        .elseif DBEvent.dwDebugEventCode == CREATE_PROCESS_DEBUG_EVENT 
	                mov edx,DBEvent.u.CreateProcessInfo.hProcess
	                mov myProcess,edx
	                mov ecx,DBEvent.u.CreateProcessInfo.hThread
	                mov myThread,ecx  
                .elseif DBEvent.dwDebugEventCode == LOAD_DLL_DEBUG_EVENT
       	                mov eax,DBEvent.u.LoadDll.lpBaseOfDll
       	                mov dwModBase,eax 
       	                .if  dwModBase < 80000000h
       	      	                invoke ReadProcessMemory,myProcess,DBEvent.u.LoadDll.lpImageName,addr OutBuff,4,NULL
       	      	                mov eax,dword ptr OutBuff
       	      	                invoke ReadProcessMemory,myProcess,eax,addr pDllName,256,NULL
       	      	                invoke Unicode2Ansi,addr pDllName,addr outinf
       	      	                invoke lstrcmp,addr outinf,addr FilePath
       	      	                .if eax==0
       	      	                        invoke wsprintf,addr OutBuff,CTEXT("LoadDll succes: handle:%08Xh,base:%08Xh,name:%s",13,10,0),DBEvent.u.LoadDll.hFile,DBEvent.u.LoadDll.lpBaseOfDll,addr outinf
       	      	                        invoke OutputInfo,addr OutBuff,0
       	      	                        mov esi,DBEvent.u.LoadDll.lpBaseOfDll
       	      	                        mov DllBase,esi 
       	      	                        add esi,EntryPiont
       	      	                        mov firstbp,esi
       	      	                        mov eax,DBEvent.u.LoadDll.hFile
       	      	                        mov hDll,eax
       	      	                .endif	 
       	      	       .endif              
       	        .elseif DBEvent.dwDebugEventCode == EXCEPTION_DEBUG_EVENT 
       	       	       .if DBEvent.u.Exception.pExceptionRecord.ExceptionCode==EXCEPTION_BREAKPOINT 
       	       	               mov Context.ContextFlags, CONTEXT_FULL
       	       	               invoke GetThreadContext, ProcessInfo.hThread, addr Context
       	       	               mov eax,Context.regEip
       	       	               mov ecx,firstbp
       	       	               inc ecx
       	       	               .if eax == ecx  
       	       	                       dec Context.regEip
       	       	                       invoke wsprintf,addr OutBuff,CTEXT("breakpoint at %.08X  ",13,10,0),Context.regEip
                                       invoke OutputInfo,addr OutBuff,0                                        
                                       mov edi,Context.regEdi
                                       mov DllBase,edi                        
                                       mov eax,Context.regEax
                                       mov firstbp,eax
                                       mov ecx,Context.regEcx
                                       mov SizeOfImage,ecx
                                       mov edx,Context.regEdx
                                       mov oldbyte,edx
                                       invoke WriteProcessMemory,ProcessInfo.hProcess,Context.regEip,oldbyte,1,0 
                                       invoke wsprintf,addr OutBuff,CTEXT("EP: %.08X,Base: %.08X,SizeImage: %.08X ",13,10,0),firstbp,DllBase,SizeOfImage
                                       invoke OutputInfo,addr OutBuff,0  
                                       invoke MessageBox,0,addr OutBuff,CTEXT("dll info"),MB_OK
                                       invoke TerminateProcess,myProcess,0
       	       	               .endif
       	       	               invoke ContinueDebugEvent,DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_CONTINUE 
       	       	               .continue          	       	          	       
       	       	       .endif
       	        .endif
       	        invoke ContinueDebugEvent,DBEvent.dwProcessId,DBEvent.dwThreadId,DBG_CONTINUE 
        .endw  
@@exit:      
        invoke CloseHandle,myProcess 
        invoke CloseHandle,ProcessInfo.hThread         
	ret

ProcessDll endp
DelLog proc
LOCAL stFindFile:WIN32_FIND_DATA
LOCAL modname[200]:byte,LogPath[256]:byte
        invoke GetModuleFileName,NULL,addr modname,sizeof modname
        invoke GetPathOnly, addr modname, addr LogPath
        invoke lstrcat, addr LogPath, CTEXT("Log.txt")
	invoke FindFirstFile,addr LogPath,addr stFindFile
	.if eax
	       invoke DeleteFile,addr LogPath	
	.endif	
	ret
DelLog endp
WriteLog proc c fmt:PTR SBYTE, args:VARARG
local hFile:HANDLE,nbr:DWORD,modname[200]:byte,temp[5000]:byte
LOCAL LogPath[256]:byte
        invoke GetModuleFileName,NULL,addr modname,sizeof modname
        invoke GetPathOnly, addr modname, addr LogPath
        invoke lstrcat, addr LogPath, CTEXT("Log.txt")
        invoke CreateFile,addr LogPath,GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
        mov hFile,eax
        .if sdword ptr eax <0
                ret
        .endif
        invoke SetFilePointer,hFile,0,0,FILE_END
        invoke wvsprintf,addr temp,fmt,addr args
        invoke lstrlen,addr temp
        mov edx,eax
        invoke WriteFile,hFile,addr temp, edx, addr nbr, NULL
        invoke CloseHandle,hFile;
        ret
WriteLog endp
OutputInfo proc OurBuffer:DWORD,flags:DWORD
LOCAL dwLen:DWORD,dwByteWritten:DWORD
LOCAL LogPath[256]:byte
LOCAL hLogFile:dword
LOCAL stFindFile:WIN32_FIND_DATA 
 	.if flags!=0
 	       invoke SetDlgItemText,hDlg,IDC_OutInf,CTEXT(0)
 	       ret
 	.endif
 	invoke SendDlgItemMessage,hDlg,IDC_OutInf,EM_SETSEL,-1,-1
 	invoke SendDlgItemMessage,hDlg,IDC_OutInf,EM_REPLACESEL,FALSE,OurBuffer
 	invoke WriteLog,OurBuffer
 	ret
OutputInfo endp
EnableDebugPrivilege proc isEnable    
local htoken:HANDLE   
local uid:LUID    
local tp:TOKEN_PRIVILEGES    
local isSuccess    
        mov isSuccess,FALSE    
        invoke GetCurrentProcess    
        lea ebx,htoken    
        invoke OpenProcessToken,eax,TOKEN_ADJUST_PRIVILEGES,    ebx            
        invoke LookupPrivilegeValue,NULL,CTEXT("SeDebugPrivilege"), addr uid   
        mov tp.PrivilegeCount,1    
        push uid.LowPart    
        pop tp.Privileges[0].Luid.LowPart    
        push uid.HighPart    
        pop tp.Privileges[0].Luid.HighPart    
        .if isEnable    
                mov tp.Privileges[0].Attributes,   SE_PRIVILEGE_ENABLED    
        .else    
                mov tp.Privileges[0].Attributes,0    
        .endif    
        invoke AdjustTokenPrivileges,htoken,FALSE,addr tp,   sizeof tp,NULL,NULL   
        invoke GetLastError    
        .if eax == ERROR_SUCCESS    
                mov isSuccess,TRUE    
        .endif    
        invoke CloseHandle,htoken    
        mov eax,isSuccess    
        ret    
EnableDebugPrivilege endp

end start 


